//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "plot.h"
#include "refdlg.h"
#include "plotdlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPlotOptDialog *PlotOptDialog;
//---------------------------------------------------------------------------
__fastcall TPlotOptDialog::TPlotOptDialog(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::FormShow(TObject *Sender)
{
	AnsiString s;
	int x=SolPlot->Left,y=SolPlot->Top,w=SolPlot->Width,h=SolPlot->Height;
	Left=x+w/2-Width/2; Top=y+h/2-Height/2;
	Color1->Color=SolPlot->CColor[0];
	Color2->Color=SolPlot->CColor[1];
	Color3->Color=SolPlot->CColor[2];
	Color4->Color=SolPlot->CColor[3];
	PlotStyle->ItemIndex=SolPlot->PlotStyle;
	MarkSize->Text=s.sprintf("%d",SolPlot->MarkSize);
	Origin->ItemIndex=SolPlot->Origin;
	TimeLabel->ItemIndex=SolPlot->TimeLabel;
	AutoScale->ItemIndex=SolPlot->AutoScale;
	ShowArrow->ItemIndex=SolPlot->ShowArrow;
	ShowStats->ItemIndex=SolPlot->ShowStats;
	YRange->Text=s.sprintf("%.2f",SolPlot->YRange);
	RefPos1->Text=s.sprintf("%.9f",SolPlot->OOPos[0]*R2D);
	RefPos2->Text=s.sprintf("%.9f",SolPlot->OOPos[1]*R2D);
	RefPos3->Text=s.sprintf("%.4f",SolPlot->OOPos[2]);
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnOKClick(TObject *Sender)
{
	SolPlot->CColor[0]=Color1->Color;
	SolPlot->CColor[1]=Color2->Color;
	SolPlot->CColor[2]=Color3->Color;
	SolPlot->CColor[3]=Color4->Color;
	SolPlot->PlotStyle=PlotStyle->ItemIndex;
	SolPlot->MarkSize=MarkSize->Text.ToInt();
	SolPlot->Origin=Origin->ItemIndex;
	SolPlot->TimeLabel=TimeLabel->ItemIndex;
	SolPlot->ShowArrow=ShowArrow->ItemIndex;
	SolPlot->ShowStats=ShowStats->ItemIndex;
	SolPlot->AutoScale=AutoScale->ItemIndex;
	SolPlot->YRange=YRange->Text.ToDouble();
	SolPlot->OOPos[0]=RefPos1->Text.ToDouble()*D2R;
	SolPlot->OOPos[1]=RefPos2->Text.ToDouble()*D2R;
	SolPlot->OOPos[2]=RefPos3->Text.ToDouble();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor1Click(TObject *Sender)
{
	ColorDialog->Color=Color1->Color;
	if (!ColorDialog->Execute()) return;
	Color1->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor2Click(TObject *Sender)
{
	ColorDialog->Color=Color2->Color;
	if (!ColorDialog->Execute()) return;
	Color2->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor3Click(TObject *Sender)
{
	ColorDialog->Color=Color3->Color;
	if (!ColorDialog->Execute()) return;
	Color3->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnColor4Click(TObject *Sender)
{
	ColorDialog->Color=Color4->Color;
	if (!ColorDialog->Execute()) return;
	Color4->Color=ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::BtnRefPosClick(TObject *Sender)
{
	AnsiString s;
	double pos[3],p[3];
	pos[0]=RefPos1->Text.ToDouble();
	pos[1]=RefPos2->Text.ToDouble();
	pos[2]=RefPos3->Text.ToDouble();
	for (int i=0;i<3;i++) RefDialog->Pos[i]=pos[i];
	if (RefDialog->ShowModal()!=mrOk) return;
	for (int i=0;i<3;i++) pos[i]=RefDialog->Pos[i];
	RefPos1->Text=s.sprintf("%.9f",pos[0]);
	RefPos2->Text=s.sprintf("%.9f",pos[1]);
	RefPos3->Text=s.sprintf("%.4f",pos[2]);
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::AutoScaleChange(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::OriginChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TPlotOptDialog::UpdateEnable(void)
{
	YRange->Enabled=AutoScale->ItemIndex==0;
	RefPos1->Enabled=Origin->ItemIndex==4;
	RefPos2->Enabled=Origin->ItemIndex==4;
	RefPos3->Enabled=Origin->ItemIndex==4;
	BtnRefPos->Enabled=Origin->ItemIndex==4;
}
//---------------------------------------------------------------------------
