/*------------------------------------------------------------------------------
* rtklib unit test driver : read rinex function
*-----------------------------------------------------------------------------*/
#include <stdio.h>
#include <assert.h>
#include "../../src/rtklib.h"

static void dumpobs(obs_t *obs)
{
	int i;
	char str[64];
	printf("obs : n=%d\n",obs->n);
	for (i=0;i<obs->n;i++) {
		time2str(obs->data[i].time,str,3);
		printf("%s : %2d %2d %13.3f %13.3f %13.3f %13.3f  %d %d\n",str,obs->data[i].sat,
			   obs->data[i].rcv,obs->data[i].L[0],obs->data[i].L[1],
			   obs->data[i].P[0],obs->data[i].P[1],obs->data[i].LLI[0],obs->data[i].LLI[1]);
	}
}
static void dumpnav(nav_t *nav)
{
	int i;
	char str[64],s1[64],s2[64];
	printf("nav : n=%d\n",nav->n);
	for (i=0;i<nav->n;i++) {
		time2str(nav->eph[i].toe,str,3);
		time2str(nav->eph[i].toc,s1,0);
		time2str(nav->eph[i].ttr,s2,0);
		printf("%s : %2d    %s %s %3d %3d %2d\n",str,nav->eph[i].sat,s1,s2,
		       nav->eph[i].iode,nav->eph[i].iodc,nav->eph[i].svh);
	}
}
void utest1(void)
{
	char *files1[]={"abc.00o","bcd.00n"};
	char *files2[]={"../07590920.05o","../07590920.05n","../30400920.05o","../30400920.05n"};
	char *files3[]={"../cagz2750.04o"};
	obs_t obs;
	nav_t nav;
	int n;
	n=readrnx(files1,2,&obs,&nav);
		assert(n==0&&!obs.data&&!nav.eph);
	n=readrnx(files2,4,&obs,&nav);
		assert(n==2880&&obs.data&&obs.n>0&&nav.eph&&nav.n>0);
	dumpobs(&obs); dumpnav(&nav);
	free(obs.data);
	free(nav.eph);

	printf("%s utest1 : OK\n",__FILE__);
}
int main(int argc, char **argv)
{
	utest1();
	return 0;
}
